% Tämä ajotiedosto animoi heilurin liikettä. Tiedostoa ei käytetä 
% laskuissa, vaan on tarkoitettu ainoastaan datan visualisointiin.

% valitaan näytettävät heilurit, esim. ix = 1:4 tai ix = 2.
ix = [1, 2, 3, 4];



% luetaan data
n = numel(ix);
D = cell(n, 1);
for ii = 1:n
    D{ii} = load(sprintf('data%i.mat', ix(ii)));
    D{ii} = D{ii}.(sprintf('data%i', ix(ii)));
end

l = 0.33;  % heilurin varren pituus

% määritellään ikkuna
f = figure(1);
clf(f)
a = axes(f);
a.DataAspectRatioMode = "manual";
a.DataAspectRatio = [1, 1, 1];
a.XTickMode = "manual";
a.XLimMode = "manual";
a.YTickMode = "manual";
a.YLimMode = "manual";
a.YLim = [-l*2, l*2];
a.XLim = [min(cellfun(@(x) min(x(1, :)), D)) - l*2,...
    max(cellfun(@(x) max(x(1, :)), D)) + l*2];

% piirretään heilurit
colors = colormap('lines');
hl = cell(n, 1);
for ii = 1:n
    hl{ii} = line(a, [D{ii}(1, 1), D{ii}(1, 1) - l*sin(D{ii}(2, 1))],...
        [0, l*cos(D{ii}(2, 1))], 'Color', colors(ix(ii), :));
end

% määritellään aikaväli
t0 = max(cellfun(@(x) x(5, 1), D));
tf = min(cellfun(@(x) x(5, end), D));

% animointi
tic
while true
    t = toc + t0;
    if t > tf
        break
    end
    for ii = 1:n
        p = interp1(D{ii}(5, :)', D{ii}([1, 2], :)', t);
        hl{ii}.XData = [p(1), p(1) - l*sin(p(2))];
        hl{ii}.YData = [0, l*cos(p(2))];
    end
    drawnow
end
