% Tm ajotiedosto estimoi kitkaparametrit minimoimalla nelivirheen
% Mrit datamatriisi x_ref ja painomatriisi R !


x_ref = ??;
R = ??;

mc = 2.4;  % vaunun massa
mp = 0.325; % heilurin massa
l = 0.33;  % heilurin varren pituus


% Alkuarvot kitkaparametreille
fc = 7;
fp = 0.006;


x0 = [fc, fp]; % Optimoitavien parametrien alkuarvot,
index = [4, 5]; % Estimoitavat parametrit (mc=1, mp=2, l=3, fc=4, fp=5)

% ! Ohjelmalla voi mys estimoida muita parametreja. Esim. jos
% haluat optimoida l:n, mc:n, ja mp:n annetuilla kitkan arvoilla,
% aseta:
% x0 = [mc, mp, l];
% index = [1, 2, 3];

% "jrkevt" ala- ja ylrajat kaikille parametreille [mc mp l fc fp] :
LBall = [1, 0.1, 0.2, 0.3, 0]';
UBall = [5, 2, 0.5, 60, 1]';

LB = LBall(index);
UB = UBall(index);


% Optimointialgoritmin parametrit:
options = optimset(...
    'LargeScale', 'off',...
    'Display', 'iter',...
    'MaxFunEvals', 10000);

% Optimointi: (estimaatit vektorissa xx, xx(1)=vaunun kitkakerroin,
% xx(2)=heilurin kitkakerroin)
xx = fmincon('optpar', x0, [], [], [], [], LB, UB, [], options, x_ref,...
    R, mc, mp, l, fc, fp, index);


% Asetetaan estimoidut parametrit vektoriin parnew, miss on kaikki
% parametrit: [mc mp l fc fp]
parnew = [mc, mp, l, fc, fp];
parnew(index) = xx;

vaunun_kitka = parnew(4)
heilurin_kitka = parnew(5)

[fo, go] = pendobj(x_ref, R, parnew(1), parnew(2), parnew(3), parnew(4),...
    parnew(5));

figure(1)

% Piirretn estimoiduilla parametreilla simuloitu trajektori (sininen), sek
% todellinen trajektori (punainen).
titles = {'Vaunun paikka', 'Heilurin kulma', 'Vaunun nopeus',...
    'Heilurin kulmanopeus'};

for ii = 1:4
    subplot(2, 2, ii)
    plot(go(:, ii + 1), 'b')
    hold on
    plot(x_ref(ii, :), 'r')
    hold off
    grid on
    title(titles{ii})
end
